// DataAcquire.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "../shared/refcount.h"
#include "../shared/archivestl.h"
#include "../gpsparser/gpsfileparser.h"
#include "../shared/filters_processing/filter_save.h"

int main(int argc, char* argv[])
{
	if (argc!=2)
	{
		printf("dataacquire gpsdatafile.txt");
		return -1;
	}

	GPSFile File;
	if (File.ReadFrom(string(argv[1]))!=GPS_ERR_OK)
	{
		printf("File read or parsing failed\n");
		return -1;
	}


	string FileNameWEx=argv[1];
	FileNameWEx.erase(FileNameWEx.rfind('.'));

	try
	{
		//pres vsechny logy
		TL::iterator it;
		for (it=File.Tracks.begin();it!=File.Tracks.end();it++)
		{
		
			//pres vsechny segmenty
			int SegNum=0;
			TSL::iterator it2;
			for (it2=(*it)->TrackSegments.begin();it2!=(*it)->TrackSegments.end();it2++,SegNum++)
			{
				char Buff[100];
				sprintf(Buff,"_%d.seg",SegNum);		
				//ulozime segment
				SaveGPSSegmentFilter SGPS((FileNameWEx+"_"+(*it)->LogName+Buff),false);
				GPSPointBuffer DataBuff;
				DataBuff.AddRef();

				list<GPSPoint>::iterator pit;
				for (pit=(*it2)->Points.begin();pit!=(*it2)->Points.end();pit++)
					DataBuff.Data.push_back(*pit);
				
				Buffer<GPSPoint>::Holder Out;
				SGPS.ProcessBuffer(&DataBuff,Out);
			}		
		}
		printf("Conversion completed\n");
		return 0;
	}
	catch(...)
	{
		printf("Conversion failed\n");
	}
	return -1;
	
}
