// ChildView.cpp : implementation of the CChildView class
//

#include "stdafx.h"
#include "DataDisplay.h"
#include "ChildView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


#include "DataToDisplayManager.h"
#include "dataspace.h"
/////////////////////////////////////////////////////////////////////////////
// CChildView

CChildView::CChildView()
{
}

CChildView::~CChildView()
{
}


BEGIN_MESSAGE_MAP(CChildView,CWnd )
	//{{AFX_MSG_MAP(CChildView)
	ON_WM_PAINT()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_RBUTTONDOWN()
	ON_WM_KEYDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CChildView message handlers

BOOL CChildView::PreCreateWindow(CREATESTRUCT& cs) 
{
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

	cs.dwExStyle |= WS_EX_CLIENTEDGE;
	cs.style &= ~WS_BORDER;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		::LoadCursor(NULL, IDC_ARROW), HBRUSH(COLOR_WINDOW+1), NULL);

	return TRUE;
}

void CChildView::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	CBrush Black(COLORREF(0));

	RECT r;
	GetClientRect(&r);
	
	if (GlobalDataSpace.ActiveDataToDisplayManager)		
	{
		GlobalDataSpace.ActiveDataToDisplayManager->SetImageRect(r);
		GlobalDataSpace.ActiveDataToDisplayManager->DrawContents(dc); //zavolame vykresleni dat
	}
	else
		dc.FillRect(&r,&Black); //nemame data->vyprazdnime obrazovku
}


void CChildView::SetViewMode(ChildViewMode NewMode)
{
	ASSERT(GlobalDataSpace.ActiveDataToDisplayManager);
	if (GlobalDataSpace.ActiveDataToDisplayManager) 
	{
		GlobalDataSpace.ActiveDataToDisplayManager->SetViewMode(NewMode);
		Invalidate(FALSE);
		UpdateWindow();
	}
}

ChildViewMode CChildView::GetViewMode()
{
	ASSERT(GlobalDataSpace.ActiveDataToDisplayManager);
	if (GlobalDataSpace.ActiveDataToDisplayManager) return GlobalDataSpace.ActiveDataToDisplayManager->GetViewMode();
	return CV_MODE_SD;
}

void CChildView::ScaleToFit(bool Proportional)
{
	ASSERT(GlobalDataSpace.ActiveDataToDisplayManager);
	if (GlobalDataSpace.ActiveDataToDisplayManager) 
	{
		RECT r;
		GetClientRect(&r);	
		GlobalDataSpace.ActiveDataToDisplayManager->SetImageRect(r);
		GlobalDataSpace.ActiveDataToDisplayManager->ScaleToFit(Proportional);	
		Invalidate(FALSE);
		UpdateWindow();
	}
}



void CChildView::OnMouseMove(UINT nFlags, CPoint point) 
{
	bool Redraw=false;

	if (GlobalDataSpace.ActiveDataToDisplayManager && (nFlags&(MK_RBUTTON|MK_LBUTTON))==(MK_RBUTTON|MK_LBUTTON) && ScaleDragStartPoint!=point) 
	{
		//tazeni obema
		GlobalDataSpace.ActiveDataToDisplayManager->Scale(FromWindowToLocal(ScaleDragStartPoint),FromWindowToLocal(point),true);
		Redraw=true;
	}
	if (GlobalDataSpace.ActiveDataToDisplayManager && (nFlags&(MK_RBUTTON|MK_LBUTTON))==MK_LBUTTON && MoveDragStartPoint!=point) 
	{		
		GlobalDataSpace.ActiveDataToDisplayManager->Move(FromWindowToLocal(MoveDragStartPoint),FromWindowToLocal(point));
		Redraw=true;
	}

	if (GlobalDataSpace.ActiveDataToDisplayManager && (nFlags&(MK_RBUTTON|MK_LBUTTON))==MK_RBUTTON && ScaleDragStartPoint!=point) 
	{
		
		GlobalDataSpace.ActiveDataToDisplayManager->Scale(FromWindowToLocal(ScaleDragStartPoint),FromWindowToLocal(point),false);
		Redraw=true;
	}

	if (Redraw)
	{	
		Invalidate(FALSE);
		UpdateWindow();
	}
	MoveDragStartPoint=point;
	ScaleDragStartPoint=point;



	if (GlobalDataSpace.ActiveDataToDisplayManager)
	{

		POINT p=FromWindowToLocal(point);
		POINTf pf;
		pf.x=p.x;
		pf.y=p.y;
		GPSPoint Position=GlobalDataSpace.ActiveDataToDisplayManager->GetPosition(pf);
		VECT3D Pos=Position;

		CString CaptionString;		

		const GPSPoint *P=GlobalDataSpace.ActiveDataToDisplayManager->GetLengthMeasureStart();
		if (P && GlobalDataSpace.ActiveDataToDisplayManager->GetViewMode()==CV_MODE_SD)
		{
			GPSPoint Distance=Position;
			Distance-=*P;			
			VECT3D Dist=Distance;
			CaptionString.Format("Pozice dlka:%f ika:%f Vzdlenost:%fm Sloky: dlka:%fm ika:%fm",Pos.d,Pos.s,GPSPoint::Distance(*P,Position),Dist.d,Dist.s);
		}
		else
		{
			CaptionString="";
			switch (GlobalDataSpace.ActiveDataToDisplayManager->GetViewMode())
			{
				case CV_MODE_SD:CaptionString.Format("Pozice dlka:%f ika:%f",Pos.d,Pos.s);break;
				case CV_MODE_SV:CaptionString.Format("Pozice sirka:%f vka:%f",Pos.s,Pos.v);break;
				case CV_MODE_DV:CaptionString.Format("Pozice dlka:%f vka:%f",Pos.d,Pos.v);break;
				case CV_MODE_LS:CaptionString.Format("Pozice kumulovan dlka:%f ika:%f",Position.DelkaNaKrivce,Pos.s);break;
				case CV_MODE_LD:CaptionString.Format("Pozice kumulovan dlka:%f dlka:%f",Position.DelkaNaKrivce,Pos.d);break;
				case CV_MODE_LV:CaptionString.Format("Pozice kumulovan dlka:%f vka:%f",Position.DelkaNaKrivce,Pos.v);break;
				case CV_MODE_NLS:CaptionString.Format("Pozice normalizovan kumulovan dlka:%f ika:%f",Position.DelkaNaKrivce,Pos.s);break;
				case CV_MODE_NLD:CaptionString.Format("Pozice normalizovan kumulovan dlka:%f dlka:%f",Position.DelkaNaKrivce,Pos.d);break;
				case CV_MODE_NLV:CaptionString.Format("Pozice normalizovan kumulovan dlka:%f vka:%f",Position.DelkaNaKrivce,Pos.v);break;
			}
		}
		GetParent()->SetWindowText(CaptionString);
	}
	
	CWnd ::OnMouseMove(nFlags, point);
}

void CChildView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	MoveDragStartPoint=point;
	CWnd ::OnLButtonDown(nFlags, point);
}

void CChildView::OnRButtonDown(UINT nFlags, CPoint point) 
{
	ScaleDragStartPoint=point;
	CWnd ::OnRButtonDown(nFlags, point);
}




CPoint CChildView::FromWindowToLocal(CPoint p)
{
	RECT r;
	GetClientRect(&r);
	CPoint Ret;
	Ret.x=p.x;
	Ret.y=r.bottom-p.y;
	return Ret;
}

CPoint CChildView::FromLocalToWindows(CPoint p)
{
	RECT r;
	GetClientRect(&r);
	CPoint Ret;
	Ret.x=p.x;
	Ret.y=r.bottom-p.y;
	return Ret;
}

void CChildView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	CWnd ::OnKeyDown(nChar, nRepCnt, nFlags);

	if (nChar=='L')
	{
		if (GlobalDataSpace.ActiveDataToDisplayManager && GlobalDataSpace.ActiveDataToDisplayManager->GetViewMode()==CV_MODE_SD)
		{
			POINT p=FromWindowToLocal(MoveDragStartPoint);
			POINTf pf;
			pf.x=p.x;
			pf.y=p.y;
			GPSPoint Position=GlobalDataSpace.ActiveDataToDisplayManager->GetPosition(pf);
			GlobalDataSpace.ActiveDataToDisplayManager->SetLengthMeasureStart(&Position);

			Invalidate(FALSE);
			UpdateWindow();
		}
	}

	if (nChar=='C')
	{
		if (GlobalDataSpace.ActiveDataToDisplayManager)
		{			
			GlobalDataSpace.ActiveDataToDisplayManager->SetLengthMeasureStart(NULL);
			Invalidate(FALSE);
			UpdateWindow();
		}
	}

}
