// DataToDisplayManager.h: interface for the CDataToDisplayManager class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DATATODISPLAYMANAGER_H__BB1CE478_96C1_423C_961F_DAFB451346F0__INCLUDED_)
#define AFX_DATATODISPLAYMANAGER_H__BB1CE478_96C1_423C_961F_DAFB451346F0__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include "stdafx.h"
#include "dataspace.h"


enum ChildViewMode {CV_MODE_SD,CV_MODE_SV,CV_MODE_DV,CV_MODE_LS,CV_MODE_LD,CV_MODE_LV,CV_MODE_NLS,CV_MODE_NLD,CV_MODE_NLV};

struct ModeDisplayInfo
{
	bool Inited;
	POINTf Delta;
	POINTf Scale;

	ModeDisplayInfo(void) {Delta.x=Delta.y=0.0f;Scale.x=Scale.y=1.0f;Inited=false;}
};

//trida udrzuje informace o datech pro zobrazovani (rezimy, scaling a seznam dat co se aktualne zobrazuji
//umoznuje zajistit vykresleni dat a realizaci operaci move, scale a scaletofit
class DataToDisplayManager
{
protected:
	ChildViewMode CurrentMode;
	ModeDisplayInfo DataProMody[9];
	listoflistoffilters DataToView;
	listofmatchingfilters MatchesToView;

	RECT RectangleOnScreen; //rectangle na obrazovce


	bool LengthMeasureStartSet; //pokud true tak se kresli krizek
	GPSPoint LengthMeasureStart;  //pocatek od ktereho se meri delky
public:	
	DataToDisplayManager();
	virtual ~DataToDisplayManager();

	void SetImageRect(RECT &r);
	
	void SetViewMode(ChildViewMode NewMode);
	ChildViewMode GetViewMode(void);
	
	void DrawContents(CDC &dc);	 //vykresli data
	GPSPoint GetPosition(POINTf &p);  //prevede zadanou pozici na obrazovce na GPSPoint souradnice

	void Scale(POINT &p1,POINT &p2,bool KeepAspect);
	void Move(POINT &p1,POINT &p2);
	void ScaleToFit(bool Proportional); //resize aby se to veslo do RectangleOnScreen


	void SetLengthMeasureStart(GPSPoint *NewStart); //nastavi novou pozici krizku, pokud je parametru NULL tak krizek zrusi
	const GPSPoint *GetLengthMeasureStart(void); //vraci nastaveny krize, NULL pokud nebyl nastaven





	listoflistoffilters &GetDataStorage(void); //vraci referenci na seznam dat na zobrazeni, pouzivano pro managing seznamu
	listofmatchingfilters &GetMatchesList(void) {return MatchesToView;}
	void ClearListOfLists(void);
	DisplayingOfProcessingFiltersListGPSPoint *CreateList(RefCounterHolder<ProcessingFiltersList<GPSPoint> > List); //vztvo list, kter je mono pidat funkci AddList
	void AddList(DisplayingOfProcessingFiltersListGPSPoint *,COLORREF Color); //prida list do seznamu listu pro zobrazeni
	void InvalidateLists(void);
	
};

#endif // !defined(AFX_DATATODISPLAYMANAGER_H__BB1CE478_96C1_423C_961F_DAFB451346F0__INCLUDED_)
