// FilterSelectDialog.cpp : implementation file
//

#include "stdafx.h"
#include "DataDisplay.h"
#include "FilterSelectDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFilterSelectDialog dialog


CFilterSelectDialog::CFilterSelectDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CFilterSelectDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFilterSelectDialog)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_FilterNames=NULL;
}


void CFilterSelectDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFilterSelectDialog)
	DDX_Control(pDX, IDC_LIST, m_List);
	DDX_Control(pDX, IDOK, m_SelectButton);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFilterSelectDialog, CDialog)
	//{{AFX_MSG_MAP(CFilterSelectDialog)
	ON_NOTIFY(NM_DBLCLK, IDC_LIST, OnDblclkList)
	ON_NOTIFY(NM_CLICK, IDC_LIST, OnClickList)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFilterSelectDialog message handlers

void CFilterSelectDialog::OnDblclkList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	int ICount=m_List.GetItemCount();
	for (int i=0;i<ICount;i++)
	{
		int State=m_List.GetItemState( i, 0xff);
		if (State&LVIS_SELECTED)
		{
			m_SelectedFilter=i;
			EndDialog(IDOK);
			break;
		}
	}		
	*pResult = 0;
}

void CFilterSelectDialog::OnClickList(NMHDR* pNMHDR, LRESULT* pResult) 
{	
	m_SelectButton.EnableWindow(TRUE);
	*pResult = 0;
}

void CFilterSelectDialog::OnOK() 
{
	int ICount=m_List.GetItemCount();
	for (int i=0;i<ICount;i++)
	{
		int State=m_List.GetItemState( i, 0xff);
		if (State&LVIS_SELECTED)
		{
			m_SelectedFilter=i;
			break;
		}
	}	
	CDialog::OnOK();
}

BOOL CFilterSelectDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_SelectButton.EnableWindow(FALSE);	
	m_SelectedFilter=-1;
	

	LVITEM Itm;
	memset(&Itm,0,sizeof(Itm));
	Itm.mask=LVIF_TEXT|LVIF_PARAM|LVIF_DI_SETITEM;
	//naplnime dialog jmeny filtru
	int Index=0;
	const char **TmpName=m_FilterNames;
	while (*TmpName)
	{
		Itm.pszText=(char *)(*TmpName);
		Itm.lParam=Itm.iItem;
		m_List.InsertItem(&Itm);
		
		Itm.iItem++; //zvetsime index
		TmpName++; //na dalsi meno
	}
	return TRUE;  // return TRUE unless you set the focus to a control
				  // EXCEPTION: OCX Property Pages should return FALSE
}
