// ListOfTracks.cpp : implementation file
//

#include "stdafx.h"
#include "DataDisplay.h"
#include "ListOfTracks.h"
#include "dataspace.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CListOfTracks dialog


CListOfTracks::CListOfTracks(CWnd* pParent /*=NULL*/)
	: CDialog(CListOfTracks::IDD, pParent)
{
	//{{AFX_DATA_INIT(CListOfTracks)
	//}}AFX_DATA_INIT
}


void CListOfTracks::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CListOfTracks)
	DDX_Control(pDX, IDC_Configure, m_Configure);
	DDX_Control(pDX, IDC_TRACKS, m_List);
	DDX_Control(pDX, IDC_DELETE, m_Delete);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CListOfTracks, CDialog)
	//{{AFX_MSG_MAP(CListOfTracks)
	ON_BN_CLICKED(IDC_DELETE, OnDelete)
	ON_BN_CLICKED(IDC_ADD, OnAdd)
	ON_NOTIFY(NM_CLICK, IDC_TRACKS, OnClickTracks)
	ON_NOTIFY(NM_DBLCLK, IDC_TRACKS, OnDblclkTracks)
	ON_BN_CLICKED(IDC_Configure, OnConfigure)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CListOfTracks message handlers
typedef unsigned long ulong;
void CListOfTracks::OnDelete() 
{
	int SCount=0;
	int ICount=m_List.GetItemCount();
	for (int i=0;i<ICount;i++)
	{
		int State=m_List.GetItemState( i, 0xff);
		if (State&LVIS_SELECTED) SCount++;
	}

	unsigned long *TracksToDelete=new ulong[SCount];
	memset(TracksToDelete,0,sizeof(unsigned long)*SCount);

	unsigned long *TracksToDeleteTmp=TracksToDelete;
	for (int j=0;j<ICount;j++)
	{
		int State=m_List.GetItemState( j, 0xff);
		if (State&LVIS_SELECTED) 
			*(TracksToDeleteTmp++)=GetIdFromString(string((LPCSTR)m_List.GetItemText(j,0)));
	}	
	GlobalDataSpace.DeleteTracks(SCount,TracksToDelete);
	delete[] TracksToDelete;
}

void CListOfTracks::OnAdd() 
{
	GlobalDataSpace.AddTrack();
	
}

void CListOfTracks::OnConfigure() 
{
	int ICount=m_List.GetItemCount();
	for (int i=0;i<ICount;i++)
	{
		int State=m_List.GetItemState( i, 0xff);
		if (State&LVIS_SELECTED) 
		{
			GlobalDataSpace.ConfigureTrack(GetIdFromString(string((LPCSTR)m_List.GetItemText(i,0))));
			break;
		}
	}
}

void CListOfTracks::OnClickTracks(NMHDR* pNMHDR, LRESULT* pResult) 
{
	UpdateButtons();	
	*pResult = 0;
}

void CListOfTracks::OnDblclkTracks(NMHDR* pNMHDR, LRESULT* pResult) 
{
	OnConfigure();
	*pResult = 0;
}

void CListOfTracks::UpdateButtons()
{
	int CEnabled=0;
	bool DEnabled=false;
	int ICount=m_List.GetItemCount();
	for (int i=0;i<ICount;i++)
	{
		int State=m_List.GetItemState( i, 0xff);
		if (State&LVIS_SELECTED) 
		{
			DEnabled=true;
			CEnabled++;
		}
	}
	m_Delete.EnableWindow(DEnabled);
	m_Configure.EnableWindow(CEnabled==1);
}


