// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "DataDisplay.h"

#include "MainFrm.h"
#include "dataspace.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_SETFOCUS()
	ON_COMMAND(ID_VIEW_DV, OnViewDv)
	ON_COMMAND(ID_VIEW_SD, OnViewSd)
	ON_COMMAND(ID_VIEW_SV, OnViewSv)
	ON_COMMAND(ID_VIEW_TOFIT, OnViewTofit)
	ON_COMMAND(ID_VIEW_SL, OnViewSl)
	ON_COMMAND(ID_VIEW_VL, OnViewVl)
	ON_COMMAND(ID_VIEW_DL, OnViewDl)
	ON_WM_TIMER()
	ON_COMMAND(ID_VIEW_DNL, OnViewDnl)
	ON_COMMAND(ID_VIEW_SNL, OnViewSnl)
	ON_COMMAND(ID_VIEW_VNL, OnViewVnl)
	ON_COMMAND(ID_VIEW_TOFITPROPORTIONAL, OnViewTofitproportional)
	ON_COMMAND(ID_FILE_SAVE, OnFileSave)
	ON_COMMAND(ID_FILE_LOAD, OnFileLoad)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	// create a view to occupy the client area of the frame
	if (!m_wndView.Create(NULL, NULL, AFX_WS_DEFAULT_VIEW,
		CRect(0, 0, 0, 0), this, AFX_IDW_PANE_FIRST, NULL))
	{
		TRACE0("Failed to create view window\n");
		return -1;
	}
	
/*	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);*/

	GlobalDataSpace.UpdateDialogs();

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	cs.dwExStyle &= ~WS_EX_CLIENTEDGE;
	cs.lpszClass = AfxRegisterWndClass(0);
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers
void CMainFrame::OnSetFocus(CWnd* pOldWnd)
{
	// forward focus to the view window
	m_wndView.SetFocus();
}
BOOL CMainFrame::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo)
{
	// let the view have first crack at the command
	if (m_wndView.OnCmdMsg(nID, nCode, pExtra, pHandlerInfo))
		return TRUE;

	// otherwise, do default handling
	return CFrameWnd::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}


void CMainFrame::OnViewDv() 
{
	m_wndView.SetViewMode(CV_MODE_DV);	
	GetMenu()->EnableMenuItem(ID_VIEW_TOFITPROPORTIONAL,MF_BYCOMMAND|MF_ENABLED);		
}

void CMainFrame::OnViewSd() 
{
	m_wndView.SetViewMode(CV_MODE_SD);
	GetMenu()->EnableMenuItem(ID_VIEW_TOFITPROPORTIONAL,MF_BYCOMMAND|MF_ENABLED);
}

void CMainFrame::OnViewSv() 
{
	m_wndView.SetViewMode(CV_MODE_SV);
	GetMenu()->EnableMenuItem(ID_VIEW_TOFITPROPORTIONAL,MF_BYCOMMAND|MF_ENABLED);
}



void CMainFrame::OnViewSl() 
{
	m_wndView.SetViewMode(CV_MODE_LS);
	GetMenu()->EnableMenuItem(ID_VIEW_TOFITPROPORTIONAL,MF_BYCOMMAND|MF_ENABLED);
}

void CMainFrame::OnViewVl() 
{
	m_wndView.SetViewMode(CV_MODE_LV);
	GetMenu()->EnableMenuItem(ID_VIEW_TOFITPROPORTIONAL,MF_BYCOMMAND|MF_ENABLED);
}

void CMainFrame::OnViewDl() 
{
	m_wndView.SetViewMode(CV_MODE_LD);
	GetMenu()->EnableMenuItem(ID_VIEW_TOFITPROPORTIONAL,MF_BYCOMMAND|MF_ENABLED);
}

void CMainFrame::OnViewDnl() 
{
	m_wndView.SetViewMode(CV_MODE_NLD);
	GetMenu()->EnableMenuItem(ID_VIEW_TOFITPROPORTIONAL,MF_BYCOMMAND|MF_GRAYED );
}

void CMainFrame::OnViewSnl() 
{
	m_wndView.SetViewMode(CV_MODE_NLS);
	GetMenu()->EnableMenuItem(ID_VIEW_TOFITPROPORTIONAL,MF_BYCOMMAND|MF_GRAYED );
	
}

void CMainFrame::OnViewVnl() 
{
	m_wndView.SetViewMode(CV_MODE_NLV);	
	GetMenu()->EnableMenuItem(ID_VIEW_TOFITPROPORTIONAL,MF_BYCOMMAND|MF_GRAYED );
}

void CMainFrame::OnViewTofit() 
{
	m_wndView.ScaleToFit(false);	
}

void CMainFrame::OnViewTofitproportional() 
{
	m_wndView.ScaleToFit(true);	
}


void CMainFrame::RedrawGraph(void)
{
	KillTimer(1235); //zastavime pripadny stary timer
	SetTimer(1235,1000,NULL);
}

void CMainFrame::RedoGraph(void) //funkce vyvola prepocet s urcitym spozdenim
{	
	KillTimer(1234); //zastavime pripadny stary timer
	SetTimer(1234,1000,NULL);
}

void CMainFrame::OnTimer(UINT nIDEvent) 
{
	if (nIDEvent==1234)
	{
		//timer spozdeneho predelani
		KillTimer(1234);
		GlobalDataSpace.ActiveDataToDisplayManager->InvalidateLists(); //zruseni vsech caches
		InvalidateRect(NULL,FALSE);
		UpdateWindow();
	}		
	if (nIDEvent==1235)
	{
		//timer spozdeneho predelani
		KillTimer(1235);
		InvalidateRect(NULL,FALSE);
		UpdateWindow();
	}		
	CFrameWnd::OnTimer(nIDEvent);
}




void CMainFrame::OnFileSave() 
{
	const char *FilesEx="Project files (*.gpr)|*.gpr|All Files (*.*)|*.*||";
	CFileDialog FDLG(false,"gpr",NULL,OFN_EXPLORER|OFN_PATHMUSTEXIST|OFN_NOREADONLYRETURN,FilesEx,this);
	if (FDLG.DoModal()==IDOK)
		GlobalDataSpace.Save(string((LPCSTR)FDLG.GetPathName()));
}

void CMainFrame::OnFileLoad() 
{
	const char *FilesEx="Project files (*.gpr)|*.gpr|All Files (*.*)|*.*||";
	CFileDialog FDLG(true,"gpr",NULL,OFN_EXPLORER|OFN_PATHMUSTEXIST|OFN_FILEMUSTEXIST,FilesEx,this);
	if (FDLG.DoModal()==IDOK)
		GlobalDataSpace.Load(string((LPCSTR)FDLG.GetPathName()));
}
