// MatchingConfig.cpp : implementation file
//

#include "stdafx.h"
#include "DataDisplay.h"
#include "MatchingConfig.h"
#include "dataspace.h"
#include "TrackSelectDialog.h"
#include "DataDisplay.h"
#include "MainFrm.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMatchingConfig dialog


CMatchingConfig::CMatchingConfig(CWnd* pParent /*=NULL*/)
	: CDialog(CMatchingConfig::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMatchingConfig)
	//}}AFX_DATA_INIT
	SelectionId=-1;
}


void CMatchingConfig::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMatchingConfig)
	DDX_Control(pDX, IDC_SAVE, m_SaveCtrl);
	DDX_Control(pDX, IDC_PICKPRIMARY, m_PickPrimaryCtrl);
	DDX_Control(pDX, IDC_PICKMERGECOLOR, m_PickMergeColorCtrl);
	DDX_Control(pDX, IDC_PICKMERGEFILTER, m_PickMergeFilterCtrl);
	DDX_Control(pDX, IDC_PICKFILTER, m_PickFilterCtrl);
	DDX_Control(pDX, IDC_PICKCOLOR, m_PickColorCtrl);
	DDX_Control(pDX, IDC_DELETESECOND, m_DeleteSecond);
	DDX_Control(pDX, IDC_CONFIGMERGEFILTER, m_ConfigMergeFiltrCtrl);
	DDX_Control(pDX, IDC_CONFIGFILTER, m_ConfigFilterCtrl);
	DDX_Control(pDX, IDC_ADDSECOND, m_AddSecondCtrl);
	DDX_Control(pDX, IDC_MERGEFILTER, m_MergeFilterName);
	DDX_Control(pDX, IDC_MERGECOLORFRAME, m_MergeColorFrame);
	DDX_Control(pDX, IDC_COLORFRAME, m_ColorFrame);
	DDX_Control(pDX, IDC_NAME, m_Name);
	DDX_Control(pDX, IDC_FILTER, m_FilterName);
	DDX_Control(pDX, IDC_MATCHES, m_Matches);
	DDX_Control(pDX, IDC_SECONDARY, m_SecondaryTracks);
	DDX_Control(pDX, IDC_PRIMARY, m_PrimaryTrack);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMatchingConfig, CDialog)
	//{{AFX_MSG_MAP(CMatchingConfig)
	ON_BN_CLICKED(IDC_ADDMATCH, OnAddmatch)
	ON_BN_CLICKED(IDC_ADDSECOND, OnAddsecond)
	ON_BN_CLICKED(IDC_CONFIGFILTER, OnConfigfilter)
	ON_BN_CLICKED(IDC_DELETEMATCH, OnDeletematch)
	ON_BN_CLICKED(IDC_PICKFILTER, OnPickfilter)
	ON_BN_CLICKED(IDC_DELETESECOND, OnDeletesecond)
	ON_NOTIFY(NM_CLICK, IDC_MATCHES, OnClickMatches)
	ON_NOTIFY(NM_CLICK, IDC_SECONDARY, OnClickSecondary)
	ON_EN_CHANGE(IDC_NAME, OnChangeName)
	ON_BN_CLICKED(IDC_PICKPRIMARY, OnPickprimary)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_PICKCOLOR, OnPickcolor)
	ON_BN_CLICKED(IDC_PICKMERGECOLOR, OnPickmergecolor)
	ON_BN_CLICKED(IDC_PICKMERGEFILTER, OnPickmergefilter)
	ON_BN_CLICKED(IDC_CONFIGMERGEFILTER, OnConfigmergefilter)
	ON_BN_CLICKED(IDC_SAVE, OnSave)
	ON_BN_CLICKED(IDC_RECALC, OnRecalc)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMatchingConfig message handlers
extern CDataDisplayApp theApp;

void CMatchingConfig::OnAddmatch() 
{	
	SingleMatchingTrack  SMT;
	SMT.Id=GlobalDataSpace.MatchingTrackId++;
	SMT.PrimaryTrack=0;
	//SMT.MatchFilter=new  ConfDeformationMatchingFilter(40.0f,70.0f,200.0f,0.1f,10.0f,0.8f);
	GlobalDataSpace.MatchingTracks.push_back(SMT);
	GlobalDataSpace.InvalidateMatches();
	GlobalDataSpace.UpdateDialogs(true);
	//GlobalDataSpace.UpdateMainWindow();
}


void CMatchingConfig::OnDeletematch() 
{		
	
	int ICount=m_Matches.GetItemCount();
	for (int i=0;i<ICount;i++)
	{
		int State=m_Matches.GetItemState( i, 0xff);
		if (State&LVIS_SELECTED)
		{
			
			int Id=GetIdFromString(string((LPCSTR)m_Matches.GetItemText(i,0)));
			listofmatchingtracks::iterator it;
			for (it=GlobalDataSpace.MatchingTracks.begin();it!=GlobalDataSpace.MatchingTracks.end();it++)
				if (it->Id==Id)
				{
					GlobalDataSpace.MatchingTracks.erase(it);
					break;
				}

			GlobalDataSpace.InvalidateMatches();
			GlobalDataSpace.UpdateDialogs(true);
			//GlobalDataSpace.UpdateMainWindow();
			break;
		}
	}	
}

void CMatchingConfig::OnAddsecond() 
{
	if (SelectionId==-1) return;
	SingleMatchingTrack *SMT= GlobalDataSpace.GetMatchById(SelectionId);
	if (!SMT) return;

	list<int> TrackIds=SelectTrack(false);

	while (TrackIds.size())
	{
		SMT->SecondaryTracks.push_back(TrackIds.front());
		TrackIds.pop_front();
	}		

	GlobalDataSpace.InvalidateMatches();
	GlobalDataSpace.UpdateDialogs(true);
	//GlobalDataSpace.UpdateMainWindow();

}

void CMatchingConfig::OnDeletesecond() 
{
	if (SelectionId==-1) return;
	SingleMatchingTrack *SMT= GlobalDataSpace.GetMatchById(SelectionId);
	if (!SMT) return;

	
	int ICount=m_SecondaryTracks.GetItemCount();
	for (int i=0;i<ICount;i++)
	{
		int State=m_SecondaryTracks.GetItemState( i, 0xff);
		if (State&LVIS_SELECTED)
		{			
			int Id=(GetIdFromString(string((LPCSTR)m_SecondaryTracks.GetItemText(i,0))));
			list<int>::iterator it;
			for (it=SMT->SecondaryTracks.begin();it!=SMT->SecondaryTracks.end();)
				if (*it==Id) 
					it=SMT->SecondaryTracks.erase(it);
				else
					it++;
		}
	}
	GlobalDataSpace.InvalidateMatches();
	GlobalDataSpace.UpdateDialogs(true);
	//GlobalDataSpace.UpdateMainWindow();
}


void CMatchingConfig::OnPickfilter() 
{
	if (SelectionId==-1) return;
	SingleMatchingTrack *SMT=GlobalDataSpace.GetMatchById(SelectionId);
	if (!SMT) return;	
	ConfigInterface *CI=GlobalDataSpace.PickFilter(FILTERCLASS_MATCHING);
	if (CI)
		SMT->MatchFilter=CI->CreateNewMatchingFilterInstance();
	GlobalDataSpace.InvalidateMatches();
	GlobalDataSpace.UpdateDialogs(true);
	//GlobalDataSpace.UpdateMainWindow();	
	
}

void CMatchingConfig::OnConfigfilter() 
{
	if (SelectionId==-1) return;
	SingleMatchingTrack *SMT= GlobalDataSpace.GetMatchById(SelectionId);
	if (!SMT) return;	
	if (SMT->MatchFilter.GetValue())
	{
		ConfigInterface *CINT=dynamic_cast<ConfigInterface *>(SMT->MatchFilter.GetValue());
		CMainFrame *Frm=dynamic_cast<CMainFrame *>(theApp.m_pMainWnd);
		CINT->ShowConfig(Frm);
	}
}


void CMatchingConfig::OnClickMatches(NMHDR* pNMHDR, LRESULT* pResult) 
{
	int ICount=m_Matches.GetItemCount();
	for (int i=0;i<ICount;i++)
	{
		int State=m_Matches.GetItemState( i, 0xff);
		if (State&LVIS_SELECTED)
		{			
			SetInfoForMatch(GetIdFromString(string((LPCSTR)m_Matches.GetItemText(i,0))));
			break;
		}
	}	
	*pResult = 0;
}

void CMatchingConfig::OnClickSecondary(NMHDR* pNMHDR, LRESULT* pResult) 
{
	
	m_DeleteSecond.EnableWindow(TRUE);
	*pResult = 0;
}

void CMatchingConfig::OnChangeName() 
{
	if (SelectionId==-1) return;
	SingleMatchingTrack *SMT=GlobalDataSpace.GetMatchById(SelectionId);
	if (!SMT) return;
	
	CString Tmp;
	m_Name.GetWindowText(Tmp);
	SMT->Name=string((LPCSTR)Tmp);
}



void CMatchingConfig::SetInfoForMatch(int MatchId)
{
	SelectionId=-1;
	m_SecondaryTracks.DeleteAllItems();
	m_PrimaryTrack.SetWindowText("");
	m_FilterName.SetWindowText("");
	m_MergeFilterName.SetWindowText("");
	m_Name.SetWindowText("");
	m_Name.EnableWindow(FALSE);

	m_SaveCtrl.EnableWindow(FALSE);
	m_PickPrimaryCtrl.EnableWindow(FALSE);
	m_PickMergeColorCtrl.EnableWindow(FALSE);
	m_PickMergeFilterCtrl.EnableWindow(FALSE);
	m_PickFilterCtrl.EnableWindow(FALSE);
	m_PickColorCtrl.EnableWindow(FALSE);
	m_DeleteSecond.EnableWindow(FALSE);
	m_ConfigMergeFiltrCtrl.EnableWindow(FALSE);
	m_ConfigFilterCtrl.EnableWindow(FALSE);
	m_AddSecondCtrl.EnableWindow(FALSE);
	m_MergeFilterName.EnableWindow(FALSE);
	m_MergeColorFrame.EnableWindow(FALSE);
	m_ColorFrame.EnableWindow(FALSE);
	m_FilterName.EnableWindow(FALSE);
	m_SecondaryTracks.EnableWindow(FALSE);
	m_PrimaryTrack.EnableWindow(FALSE);

	if (MatchId==-1) return;

	SingleMatchingTrack *SMT= GlobalDataSpace.GetMatchById(MatchId);
	if (!SMT) return;
	SelectionId=SMT->Id;


	SingleTrackInfo *Trk=GlobalDataSpace.GetTrackById(SMT->PrimaryTrack);
	if (Trk && Trk->TrackId) //pokud zadan primarni track tak ho nastavime do dialogu
		m_PrimaryTrack.SetWindowText(IdAStringToString(Trk->TrackId,Trk->FileName).c_str());

	//pokud zadany sekudarni tracky tak je pridame do dialogu
	list<int>::iterator it2;
	for (it2=SMT->SecondaryTracks.begin();it2!=SMT->SecondaryTracks.end();it2++)
	{
		SingleTrackInfo *Trk=GlobalDataSpace.GetTrackById(*it2);
		if (!Trk) continue;
		string s=IdAStringToString(Trk->TrackId,Trk->FileName);

		LVITEM Itm;
		memset(&Itm,0,sizeof(Itm));
		Itm.mask=LVIF_TEXT|LVIF_DI_SETITEM;
		Itm.pszText=(char *)s.c_str();
		m_SecondaryTracks.InsertItem(&Itm);
	}

	m_FilterName.SetWindowText("");
	m_MergeFilterName.SetWindowText("");
	//pokud zadan filtr tak ho nastavime v dialogu
	if (SMT->MatchFilter.GetValue())
	{
		ConfigInterface *CI=dynamic_cast<ConfigInterface *>(SMT->MatchFilter.GetValue());
		m_FilterName.SetWindowText(CI->GetName());
	}
	if (SMT->MergeFilter.GetValue())
	{
		ConfigInterface *CI=dynamic_cast<ConfigInterface *>(SMT->MergeFilter.GetValue());
		m_MergeFilterName.SetWindowText(CI->GetName());
	}	
	m_Name.SetWindowText(SMT->Name.c_str());
	m_Name.EnableWindow(TRUE);

	
	m_PickPrimaryCtrl.EnableWindow(TRUE);
	m_PickMergeColorCtrl.EnableWindow(TRUE);
	m_PickMergeFilterCtrl.EnableWindow(TRUE);
	m_PickFilterCtrl.EnableWindow(TRUE);
	m_PickColorCtrl.EnableWindow(TRUE);
	
	
	m_AddSecondCtrl.EnableWindow(TRUE);
	m_MergeFilterName.EnableWindow(TRUE);
	m_MergeColorFrame.EnableWindow(TRUE);
	m_ColorFrame.EnableWindow(TRUE);
	m_FilterName.EnableWindow(TRUE);
	m_SecondaryTracks.EnableWindow(TRUE);
	m_PrimaryTrack.EnableWindow(TRUE);

	if (SMT->MatchFilter.GetValue())
		m_ConfigFilterCtrl.EnableWindow(TRUE);

	if (SMT->MergeFilter.GetValue())
		m_ConfigMergeFiltrCtrl.EnableWindow(TRUE);

	if (SMT->MatchFilter.GetValue() && SMT->MergeFilter.GetValue())
		m_SaveCtrl.EnableWindow(TRUE);

	InvalidateRect(NULL);
	UpdateWindow();
}



void CMatchingConfig::OnPickprimary() 
{
	if (SelectionId==-1) return;
	SingleMatchingTrack *SMT= GlobalDataSpace.GetMatchById(SelectionId);
	if (!SMT) return;

	list<int> TrackIds=SelectTrack(true);
	if (TrackIds.size())
	{
		SMT->PrimaryTrack=TrackIds.front();
		GlobalDataSpace.InvalidateMatches();
		GlobalDataSpace.UpdateDialogs(true);
		//GlobalDataSpace.UpdateMainWindow();
	}
}

int CMatchingConfig::GetSelectedTrackId()
{
	return SelectionId;
}

void CMatchingConfig::OnPaint() 
{
	CPaintDC dc(this); // device context for painting

	if (SelectionId==-1) return;
	SingleMatchingTrack *SMT= GlobalDataSpace.GetMatchById(SelectionId);
	if (!SMT) return;

	RECT r;
	m_ColorFrame.GetWindowRect(&r);
	ScreenToClient(&r);
	CBrush B(SMT->Color);
	dc.FillRect(&r,&B);

	m_MergeColorFrame.GetWindowRect(&r);
	ScreenToClient(&r);
	CBrush B2(SMT->MergeColor);
	dc.FillRect(&r,&B2);
}

void CMatchingConfig::OnPickcolor() 
{
	if (SelectionId==-1) return;
	SingleMatchingTrack *SMT= GlobalDataSpace.GetMatchById(SelectionId);
	if (!SMT) return;

	CColorDialog CCD(SMT->Color,CC_SOLIDCOLOR);
	if (CCD.DoModal()==IDOK)
	{
		SMT->Color=CCD.GetColor();	
		InvalidateRect(NULL);
		UpdateWindow();
		//GlobalDataSpace.UpdateMainWindow();
		GlobalDataSpace.UpdateDialogs(true);
	}	
}



void CMatchingConfig::OnPickmergecolor() 
{
	if (SelectionId==-1) return;
	SingleMatchingTrack *SMT= GlobalDataSpace.GetMatchById(SelectionId);
	if (!SMT) return;

	CColorDialog CCD(SMT->MergeColor,CC_SOLIDCOLOR);
	if (CCD.DoModal()==IDOK)
	{
		SMT->MergeColor=CCD.GetColor();	
		InvalidateRect(NULL);
		UpdateWindow();
		//GlobalDataSpace.UpdateMainWindow();
		GlobalDataSpace.UpdateDialogs(true);
	}	
}

void CMatchingConfig::OnPickmergefilter() 
{
	if (SelectionId==-1) return;
	SingleMatchingTrack *SMT=GlobalDataSpace.GetMatchById(SelectionId);
	if (!SMT) return;	
	ConfigInterface *CI=GlobalDataSpace.PickFilter(FILTERCLASS_MERGING);
	if (CI) SMT->MergeFilter=CI->CreateNewMergingFilterInstance();
	GlobalDataSpace.UpdateDialogs(true);
	SetInfoForMatch(SelectionId);
	//GlobalDataSpace.UpdateMainWindow();	
}

void CMatchingConfig::OnConfigmergefilter() 
{
	if (SelectionId==-1) return;
	SingleMatchingTrack *SMT= GlobalDataSpace.GetMatchById(SelectionId);
	if (!SMT) return;	
	if (SMT->MergeFilter.GetValue())
	{
		ConfigInterface *CINT=dynamic_cast<ConfigInterface *>(SMT->MergeFilter.GetValue());
		CMainFrame *Frm=dynamic_cast<CMainFrame *>(theApp.m_pMainWnd);
		CINT->ShowConfig(Frm);
	}	
}



#include "filters\configurablefilter_save.h"

extern CDataDisplayApp theApp;
void CMatchingConfig::OnSave() 
{
	//nejdrive zjistime strukturu pro aktualni match
	if (SelectionId==-1) return;
	SingleMatchingTrack *SMT= GlobalDataSpace.GetMatchById(SelectionId);
	if (!SMT) return;
	GPSPointBuffer::Holder Generated=GlobalDataSpace.GenerateResultCurveForSelectedMatch(SMT);
	if (Generated.GetValue()==NULL)
	{
		MessageBox("Chybn konfigurace. Chyb nebo je patn primrn trasa i chyb filtry.","",MB_OK);
		return;
	}


	const char *FilesEx="Segment files (*.seg)|*.seg|All Files (*.*)|*.*||";
	CFileDialog FDLG(false,"seg",NULL,OFN_EXPLORER|OFN_PATHMUSTEXIST|OFN_NOREADONLYRETURN,FilesEx,theApp.m_pMainWnd);
	if (FDLG.DoModal()==IDOK)
	{
		SaveGPSSegmentFilter SSF(string((LPCSTR)FDLG.GetPathName()),false);
		SSF.ProcessBuffer(Generated,Generated);
	}
}

void CMatchingConfig::OnRecalc() 
{
	GlobalDataSpace.InvalidateMatches();
	GlobalDataSpace.UpdateDialogs();
	GlobalDataSpace.UpdateMainWindow();		
}
