
#include "configurablefilter_clipstart.h"
#include "..\ClipStartDialog.h"


void CIFILTERNAME::DoOperation(Archive &archiv,int Version)
{
	archiv<<=Precision;
	archiv<<=MinMergedForStart;
	archiv<<=IgnoreFirstNumPoints;
	archiv<<=MaxSkipPoints;
	
}

ProcessingFilter<GPSPoint> *CIFILTERNAME::CreateNewProcessingFilterInstance(void)
{
	return new CIFILTERNAME(Precision,MinMergedForStart,IgnoreFirstNumPoints,MaxSkipPoints);
}

CDialog *CIFILTERNAME::CreateConfigDialog(void)
{
	CIDIALOGNAME *Dlg=new CIDIALOGNAME;		
	Dlg->ParentObject=this;
	Dlg->Create((UINT)(CIDIALOGNAME::IDD),(CWnd *)MainFrame);
	return Dlg;
}

void CIFILTERNAME::SyncConfigDialog(CDialog *SyncWithDialog,bool ConfigureDialog)
{
	CIDIALOGNAME *Ptr=dynamic_cast<CIDIALOGNAME *>(SyncWithDialog);
	if (ConfigureDialog)
	{
		Ptr->m_IgnoreFirstN=IgnoreFirstNumPoints;
		Ptr->m_MinimalMergendCount=MinMergedForStart;
		Ptr->m_Precision=Precision;
		Ptr->m_MaxSkip=MaxSkipPoints;
		Ptr->UpdateData(FALSE);
	}
	else
	{
		if (Ptr->UpdateData(TRUE))
		{
			IgnoreFirstNumPoints=Ptr->m_IgnoreFirstN;
			MinMergedForStart=Ptr->m_MinimalMergendCount;
			MaxSkipPoints=Ptr->m_MaxSkip;
			Precision=Ptr->m_Precision;
		}
	}

}


