
#include "configurablefilter_deformmatch.h"
#include "..\DeformationMatchingDialog.h"

void CIFILTERNAME::DoOperation(Archive &archiv,int Version)
{
	archiv<<=AngleChangePenalty;
	archiv<<=ZeroCrossingPenalty;
	archiv<<=PenaltaZaPootoceni;
	archiv<<=MinimalniPenaltovanePootoceni;
	archiv<<=Ks;
	archiv<<=Cs;
	archiv<<=MaxChangeAllowed;
}


MatchingFilter<GPSPoint> *CIFILTERNAME::CreateNewMatchingFilterInstance(void)
{
	return new CIFILTERNAME(AngleChangePenalty,ZeroCrossingPenalty,PenaltaZaPootoceni,MinimalniPenaltovanePootoceni,Ks,Cs,MaxChangeAllowed);
}

CDialog *CIFILTERNAME::CreateConfigDialog(void)
{
	CIDIALOGNAME *Dlg=new CIDIALOGNAME;		
	Dlg->ParentObject=this;
	Dlg->Create((UINT)(CIDIALOGNAME::IDD),(CWnd *)MainFrame);
	return Dlg;
}

void CIFILTERNAME::SyncConfigDialog(CDialog *SyncWithDialog,bool ConfigureDialog)
{
	CIDIALOGNAME *Ptr=dynamic_cast<CIDIALOGNAME *>(SyncWithDialog);
	if (ConfigureDialog)	
	{
		Ptr->m_AngleChangePenalty=AngleChangePenalty;
		Ptr->m_ZeroCrossingPenalty=ZeroCrossingPenalty;
		Ptr->m_PenaltaZaPootoceni=PenaltaZaPootoceni;
		Ptr->m_MinimalniPenaltovanePootoceni=MinimalniPenaltovanePootoceni;
		Ptr->m_Ks=Ks;
		Ptr->m_Cs=Cs;
		Ptr->m_MaxChangeAllowed=MaxChangeAllowed;
		Ptr->UpdateData(FALSE);
	}
	else
	{
		if (Ptr->UpdateData(TRUE))
		{
			AngleChangePenalty=Ptr->m_AngleChangePenalty;
			ZeroCrossingPenalty=Ptr->m_ZeroCrossingPenalty;
			PenaltaZaPootoceni=Ptr->m_PenaltaZaPootoceni;
			MinimalniPenaltovanePootoceni=Ptr->m_MinimalniPenaltovanePootoceni;
			MaxChangeAllowed=Ptr->m_MaxChangeAllowed;
			Ks=Ptr->m_Ks;
			Cs=Ptr->m_Cs;
		}
	}
}


