#include "confinterface.h"
#include "..\MainFrm.h"

ConfigInterface::~ConfigInterface(void)
{
	if (DialogPointer) 
	{
		DialogPointer->DestroyWindow();
		delete DialogPointer;
	}
	DialogPointer=NULL;
	MainFrame=NULL;
}

void ConfigInterface::SetCachesList(ListOfInvalidatableCaches::Holder CachesList)
{
	Caches=CachesList;
}

ListOfInvalidatableCaches::Holder ConfigInterface::GetCachesList(void)
{
	return Caches;
}


void ConfigInterface::ShowConfig(CMainFrame *Frm)
{
	MainFrame=Frm;
	if (!DialogPointer)
		DialogPointer=CreateConfigDialog();

	SyncConfigDialog(DialogPointer,true);
	DialogPointer->ShowWindow(SW_SHOW);
}


void ListOfInvalidatableCaches::InvalidateAll(void)
{
	ListOfInvalidatableCaches::iterator it;
	for (it=begin();it!=end();it++) 
		if (it->GetValue()!=NULL)
			(*it)->Invalidate();
}

void ConfigInterface::DialogUpdated(void)
{	
	SyncConfigDialog(DialogPointer,false);

	if (Caches) Caches->InvalidateAll();
	if (MainFrame) MainFrame->RedrawGraph(); 	//vyvolame refresh dat	
}
