#ifndef DATAPARSER_H
#define DATAPARSER_H
#pragma warning (disable:4786)

#include "../shared/refcount.h"
#include <stdlib.h>
#include <memory.h>

#include <string>
#include <vector>
#include <map>
using namespace std;
typedef vector<string, allocator<string> > STRING_V;
typedef multimap<int, string, less<int>, allocator<string> > INT_to_STRING;

typedef const char *ConstCStr;

struct ParserGraphItem:public RefCounter
	{
	public:
	char ValidString; //pokud retezec skonci na tomto prvku tak je prijat
	struct ParserGraphItem *Childs[256];
	char ReleaseChild[256]; //jestli se zadane dite ma uvolnovat  
	char StoreCodeIndex[256];
	
	ParserGraphItem(void) {ValidString=0;memset(Childs,0,sizeof(Childs));memset(StoreCodeIndex,0,sizeof(StoreCodeIndex));memset(ReleaseChild,0,sizeof(ReleaseChild));};
	~ParserGraphItem(void) {Clean();}; 
	void Clean(void)
		{
		for (int x=0;x<256;x++) 
			if (ReleaseChild[x]) SAFE_REL(Childs[x]);
		memset(Childs,0,sizeof(Childs));
		memset(StoreCodeIndex,0,sizeof(StoreCodeIndex));
		memset(ReleaseChild,0,sizeof(ReleaseChild));
		};
	};


typedef void (*ParseCallback)(int Index,string &s,void *UserData);

class DataParser:public RefCounter
	{
	ParserGraphItem Koren;	
	string CmdStr;
	int Generated; //byl z aktualniho CmdStr uz vygenerovan graf?

	public:

	DataParser(void) {CmdStr="";Generated=0;};
	DataParser(const DataParser &s) {CmdStr=s.CmdStr;Koren.Clean();Generated=0;};
	DataParser(const string CmdString) {CmdStr=CmdString;Generated=0;};

	const DataParser &operator=(const DataParser &s) {CmdStr=s.CmdStr;Koren.Clean();Generated=0;return *this;};
	
	//pokud NULL tak se pouzije CmdStr
	bool BuidGraph(ConstCStr CmdString=NULL);

	//callback muze byt zavolan i kdyz retezec nematchuje !!!
	//callback parametr Index je 1 based a udava kolikate jsou prislusne zavorky v CmdString
	bool ParseString(ConstCStr String,ParseCallback Callback,void *CallbackData);		
	bool ParseStringEx(ConstCStr String,INT_to_STRING &Output);
	};




#endif