#pragma warning (disable:4786)
#include "../shared/refcount.h"
#include "GPSFileParser.h"
#include "DataParser.h"
#include <stdlib.h>
#include <stdio.h>


#define TMPBUFFSIZE 1000



void GPSFileObject::DoOperation(Archive &archiv,int Version)
{
	archiv<<=Parrent;		
}


void TrackLogSegment::DoOperation(Archive &archiv,int Version)
{
	GPSFileObject::DoOperation(archiv,Version);
	archiv<<=Points;		
}



void TrackLog::DoOperation(Archive &archiv,int Version)
{
	GPSFileObject::DoOperation(archiv,Version);
	archiv<<=LogName;
	archiv<<=TrackSegments;
}

void GPSFile::DoOperation(Archive &archiv,int Version)
{
	GPSFileObject::DoOperation(archiv,Version);
	STOREENUM(archiv,Mode,GPSFileMode);
	archiv<<=CurrentFileName;
	archiv<<=Tracks;
}



int GPSFile::ReadFrom(const string &FileName)
{
	Tracks.clear();
	FILE *f=NULL;
	

	try
	{
		f=fopen(FileName.c_str(),"rt");
		if (!f) throw GPS_ERR_FILEIO;		
	
		DataParser TrackItem("T +{[NS]}{[0123456789]+} +{[0123456789.]+} +{[EW]}{[0123456789]+} +{[0123456789.]+} +{[^;]+}; +{[0123456789.]+}; +{[e0123456789.]+};?*");
		DataParser TrackItemMode2("T +{[0123456789]+}{[U]} +{[0123456789.]+} +{[0123456789.]+} +{[^;]+}; +{[0123456789.]+}; +{[e0123456789.]+};?*");
		DataParser NewSegment("N +New +Track +Segment +Start?*");
		DataParser NewLog("N +New +Track +Log +Start +- {[^,]*},?*");
		DataParser ModeInfo("M +{[DMUT]+}[^DMUT]*");
		TLHolder ActiveTrackLog;
		TLSHolder ActiveTrackSegment;

		char TmpBuff[TMPBUFFSIZE];
		TmpBuff[TMPBUFFSIZE-1]=0;
		
		while (!feof(f))
		{			
			if (fgets(TmpBuff,TMPBUFFSIZE-1,f)==NULL) break;
			INT_to_STRING Result;
			bool Log=false;
			
			switch (TmpBuff[0])
			{
				case 'M':
					if (ModeInfo.ParseStringEx(TmpBuff,Result))
					{
						INT_to_STRING::iterator ModeString=Result.find(0);
						if (ModeString->second=="DMM") {Mode=FILE_STUPNE;break;};
						if (ModeString->second=="UTM") {Mode=FILE_METRY;break;};
						throw GPS_ERR_FORMAT;						
					}
					else
						throw GPS_ERR_FORMAT;
					break;
				case 'N':
					if (NewSegment.ParseStringEx(TmpBuff,Result) ||
						(Log=NewLog.ParseStringEx(TmpBuff,Result))
						)
					{												
						if (ActiveTrackSegment.GetValue() && ActiveTrackLog.GetValue())								
						{
							ActiveTrackSegment->Parrent=ActiveTrackLog;
							ActiveTrackLog->TrackSegments.push_back(ActiveTrackSegment);
						}
							
						ActiveTrackSegment=new TrackLogSegment;
						if (!ActiveTrackSegment.GetValue()) throw GPS_ERR_MEMORY;
						
						if (Log)
						{
							if (ActiveTrackLog.GetValue())
							{
								Tracks.push_back(ActiveTrackLog);
								ActiveTrackLog->Parrent=this;
							}
							
							ActiveTrackLog=new TrackLog;							
							if (!ActiveTrackLog.GetValue()) throw GPS_ERR_MEMORY;
							ActiveTrackLog->LogName=Result.find(0)->second;
						}	
					
					}
					else							
					throw GPS_ERR_FORMAT;

					break;
				case 'T':
					if (Mode==FILE_STUPNE)
						if (TrackItem.ParseStringEx(TmpBuff,Result))
						{
							INT_to_STRING::iterator SirkaSymbol=Result.find(0);
							INT_to_STRING::iterator DegS=Result.find(1);
							INT_to_STRING::iterator SecS=Result.find(2);
							
							INT_to_STRING::iterator DelkaSymbol=Result.find(3);
							INT_to_STRING::iterator DegD=Result.find(4);
							INT_to_STRING::iterator SecD=Result.find(5);
						
							INT_to_STRING::iterator Datum=Result.find(6);
							INT_to_STRING::iterator Vyska=Result.find(7);
						
							FTYPE DD=atof(DegD->second.c_str());
							DD+=atof(SecD->second.c_str())/60.0f;
						
							FTYPE DS=atof(DegS->second.c_str());
							DS+=atof(SecS->second.c_str())/60.0f;
						
							FTYPE H=atof(Vyska->second.c_str());
						
							assert(ActiveTrackSegment.GetValue());
						
							
							VECT3D V;
							
							switch (DelkaSymbol->second.c_str()[0])						
							{
								case 'W':V.d=-DD;break; 
								case 'E':V.d=DD;break;
								default:throw GPS_ERR_FORMAT;
							}
							switch (SirkaSymbol->second.c_str()[0])						
							{
								case 'N':V.s=DS;break;//sirka 90 je severni pol
								case 'S':V.s=-DS;break;
								default:throw GPS_ERR_FORMAT;
							}
							V.v=H;

							GPSPoint Gp;
							Gp.InitByStupne(V);
							ActiveTrackSegment->Points.push_back(Gp);					
						}
						else
						throw GPS_ERR_FORMAT;
					if (Mode==FILE_METRY)
						if (TrackItemMode2.ParseStringEx(TmpBuff,Result))
						{
							//INT_to_STRING::iterator Cosi=Result.find(1);
							INT_to_STRING::iterator Delka=Result.find(2);							
							INT_to_STRING::iterator Sirka=Result.find(3);
						
							INT_to_STRING::iterator Datum=Result.find(4);
							INT_to_STRING::iterator Vyska=Result.find(5);
						
							FTYPE DD=atof(Delka->second.c_str());
						
							FTYPE DS=atof(Sirka->second.c_str());
						
							FTYPE H=atof(Vyska->second.c_str());
						
							assert(ActiveTrackSegment.GetValue());						

							VECT3D V;
							V.d=DD;
							V.s=DS;
							V.v=H;
							GPSPoint Gp;
							Gp.InitByMetry(V);
							ActiveTrackSegment->Points.push_back(Gp);					
						}
						else
						throw GPS_ERR_FORMAT;					
			}
		}
		if (ActiveTrackLog.GetValue() && ActiveTrackSegment.GetValue())
		{
			ActiveTrackLog->TrackSegments.push_back(ActiveTrackSegment);
			Tracks.push_back(ActiveTrackLog);

			ActiveTrackSegment->Parrent=ActiveTrackLog;
			ActiveTrackLog->Parrent=this;

			ActiveTrackSegment=NULL;
			ActiveTrackLog=NULL;
		}
	
		fclose(f);
	}
	catch(int i)
	{
		if (f) fclose(f);
		return i;
	}
	CurrentFileName=FileName;
	return GPS_ERR_OK;	
}
