#ifndef GPSFILEPARSER_H
#define GPSFILEPARSER_H


#pragma warning (disable:4786)

#include <assert.h>
#include "../shared/refcount.h"
#include "../shared/archivestl.h"
#include <list>
#include <string>
using namespace std;

#define GPS_ERR_OK 0
#define GPS_ERR_FILEIO -1
#define GPS_ERR_MEMORY -2
#define GPS_ERR_FORMAT -3

#include "../shared/gpspoint.h"



#define GPSFO_TYPE_UNKNOWN 0
#define GPSFO_TYPE_SEGMENT 1
#define GPSFO_TYPE_LOG 2
#define GPSFO_TYPE_FILE 2

class GPSFileObject:public RefCounter,public Archivable
{
	public:
	ARCHIVABLENOINVAL(GPSFileObject,GPS,1,1,1)

	RefCounterHolder<GPSFileObject,true> Parrent;

	GPSFileObject(void) {Parrent=NULL;};
	virtual ~GPSFileObject(void) {};
	virtual int GetType(void) {return GPSFO_TYPE_UNKNOWN;}
};


class TrackLogSegment:public GPSFileObject
{
	public:	
	ARCHIVABLENOINVAL(TrackLogSegment,GPS,1,1,1)

    list<GPSPoint> Points;

	TrackLogSegment(void) {};
	virtual int GetType(void) {return GPSFO_TYPE_SEGMENT;};
};

typedef RefCounterHolder<TrackLogSegment> TLSHolder;
typedef list<TLSHolder> TSL;

class TrackLog:public GPSFileObject
{
	public:
	ARCHIVABLENOINVAL(TrackLog,GPS,1,1,1)


	TSL TrackSegments;
	string LogName;

	virtual int GetType(void) {return GPSFO_TYPE_LOG;};

};


typedef RefCounterHolder<TrackLog> TLHolder;
typedef list<TLHolder> TL;


class GPSFile:public GPSFileObject
{
	public:
	ARCHIVABLENOINVAL(GPSFile,GPS,1,1,1)


	TL Tracks;	
	string CurrentFileName;
	enum GPSFileMode {FILE_STUPNE,FILE_METRY} Mode;

	GPSFile(void) {Mode=FILE_STUPNE;};
	
	int ReadFrom(const string &FileName);		
	virtual int GetType(void) {return GPSFO_TYPE_FILE;};

};


typedef RefCounterHolder<GPSFile> GPSFHolder;
typedef list<GPSFHolder> GPSFILELIST;

#endif


