#ifndef ARCHIVESTL_H
#define ARCHIVESTL_H

#pragma warning (disable:4786)
#include "archive.h"

#include <string>
#include <list>
#include <map>
#include <deque>
#include <set>
#include <vector>
using namespace std;

Archive &operator<<=(Archive &archiv,string &s);

template<class X>
Archive &StoreIterated(Archive &archiv,X &s)
{	
	if (archiv.DoLoad())
	{
		s.clear();
		int Count;
		archiv<<=Count;
		for (int x=0;x<Count;x++)
		{
			X::value_type Tmp;
			s.push_back(Tmp);
			archiv<<=s.back();
		}
	}
	else
	{
		int Count=s.size();
		archiv<<=Count;
		X::iterator it;
		for (it=s.begin();it!=s.end();it++)
			archiv<<=(*it);
	}	
	return archiv;
}



template<class X>
Archive &operator<<=(Archive &archiv,list<X> &s)
{
	return StoreIterated(archiv,s);
}

template<class X>
Archive &operator<<=(Archive &archiv,vector<X> &s)
{
	return StoreIterated(archiv,s);
}

template<class X>
Archive &operator<<=(Archive &archiv,deque<X> &s)
{
	return StoreIterated(archiv,s);
}


template<class X>
Archive &operator<<=(Archive &archiv,set<X> &s)
{	
	if (archiv.DoLoad())
	{
		s.clear();
		int Count;
		archiv<<=Count;
		for (int x=0;x<Count;x++)
		{
			X::value_type Tmp;
			archiv<<=s.insert(Tmp).first;
		}
	}
	else
	{
		int Count=s.count();
		archiv<<=Count;
		set<X>::iterator it;
		for (it=s.begin();it!=s.end();it++)
			archiv<<=(*it);
	}	
	return archiv;
}


template<class X,class Y>
Archive &operator<<=(Archive &archiv,map<X,Y> &s)
{
	if (archiv.DoLoad())
	{
		s.clear();
		int Count;
		archiv<<=Count;
		for (int x=0;x<Count;x++)
		{
			X::value_type Tmp;
			X::iterator it=s.insert(Tmp).first;
			archiv<<=it->first;
			archiv<<=it->second;
		}
	}
	else
	{
		int Count=s.count();
		archiv<<=Count;
		X::iterator it;
		for (it=s.begin();it!=s.end();it++)
		{
			archiv<<=it->first;
			archiv<<=it->second;
		}
	}	
	return archiv;
}

template<class X,class Y>
Archive &operator<<=(Archive &archiv,multimap<X,Y> &s)
{
	if (archiv.DoLoad())
	{
		s.clear();
		int Count;
		archiv<<=Count;
		for (int x=0;x<Count;x++)
		{
			X::value_type Tmp;
			X::iterator it=s.insert(Tmp);
			archiv<<=it->first;
			archiv<<=it->second;
		}
	}
	else
	{
		int Count=s.count();
		archiv<<=Count;
		X::iterator it;
		for (it=s.begin();it!=s.end();it++)
		{
			archiv<<=it->first;
			archiv<<=it->second;
		}
	}	
	return archiv;
}


#endif