#ifndef FILTER_H
#define FILTER_H

#include "buffer.h"
#include "display.h"
class Filter:public RefCounter
{
    public:
};


template<class X>
class ProcessingFilter:public Filter
{
     public:
     virtual void ProcessBuffer(Buffer<X>::Holder InBuffer,Buffer<X>::Holder &OutBuffer)=0;
     //provede zpracovani
     //na vstupu buffer s daty, do OutBuffer da buffer z transformovanymi daty
};


template<class X>
class MatchingFilter:public Filter
{
     public:
     virtual void MatchCurves(Buffer<X>::Holder Curve1,Buffer<X>::Holder Curve2,Buffer<CrossInfo<X> >::Holder &MatchResult)=0;
     //vygeneruje informace o sounalezejicich bodech
};

template<class X>
struct MatchPair:public Archivable
{
     Buffer<X>::Holder Curve;
     Buffer<CrossInfo<X> >::Holder MatchData;


     ARCHIVABLEEXDIRECTIMPL(MatchPair,X,1,1,1)
     virtual void DoOperation(Archive &archiv,int Version) {archiv<<=Curve;archiv<<=MatchData;}
     virtual void Invalidate(void) {}

};

template<class X>
class MergingFilter:public Filter
{
     public:
     virtual void GenerateResult(Buffer<X>::Holder PrimaryCurve,Buffer<MatchPair<X> >::Holder Matches,Buffer<X>::Holder &ResultCurve)=0;
     //vygeneruje krivku sestavenou z krivek pomoci matchovacich dat
};


template<class X>
class DisplayingFilter:public Filter
{
     public:
	 virtual void DisplayCrossBuffer(Buffer<CrossInfo<X> >::Holder Buffer,DisplayInterface<X>::Holder Display)=0;
     virtual void DisplayBuffer(Buffer<X>::Holder Buffer,DisplayInterface<X>::Holder Display)=0;
     
     //zobrazi data pomoci zadaneho interface
};


#endif
