#ifndef FILTER_DEFORMMATCH_H
#define FILTER_DEFORMMATCH_H

#include "..\filter.h"
#include "..\gpspoint.h"

class DeformationMatchingFilter:public MatchingFilter<GPSPoint>
{
     protected:
     float AngleChangePenalty; //penalta ze zmenu uhlu
     float ZeroCrossingPenalty; //penalta za prechod pres nulu
     float PenaltaZaPootoceni;
     float MinimalniPenaltovanePootoceni;
     float Ks;
     float Cs; 
	 float MaxChangeAllowed;
     public:
     DeformationMatchingFilter(float ACHP,float ZCP,float PZP,float MPP,float KS,float CS,float MaxChange) 
     {
		AngleChangePenalty=ACHP;
		ZeroCrossingPenalty=ZCP;
		PenaltaZaPootoceni=PZP;
		MinimalniPenaltovanePootoceni=MPP;
		Ks=KS;
		Cs=CS;
		MaxChangeAllowed=MaxChange;
     }

     virtual void MatchCurves(GPSPointBuffer::Holder Curve1,GPSPointBuffer::Holder Curve2,Buffer<CrossInfo<GPSPoint> >::Holder &MatchResult);
     
     private:
     FTYPE GetAngle(FTYPE x,FTYPE y);
     int GetQuadrant(FTYPE Uhel);
     FTYPE SpocitatOhybaciPraci(GPSPoint &SP1,GPSPoint &SP2,GPSPoint &SP3,GPSPoint &DP1,GPSPoint &DP2,GPSPoint &DP3);
     FTYPE SpocitatNatahovaciPraci(GPSPoint &SP1,GPSPoint &SP2,GPSPoint &DP1,GPSPoint &DP2);
};

#endif