#include "filter_clipstart.h"

void ClipStartFilter::ProcessBuffer(GPSPointBuffer::Holder InBuffer,GPSPointBuffer::Holder &OutBuffer)
{
	OutBuffer=NULL;
	if (InBuffer==NULL) return;

	OutBuffer=new GPSPointBuffer;
	GPSPointBuffer *IBuff=dynamic_cast<GPSPointBuffer *>(InBuffer.GetValue());
	GPSPointBuffer *OBuff=dynamic_cast<GPSPointBuffer *>(OutBuffer.GetValue());
	OBuff->FileName=IBuff->FileName;
	GPSPointBuffer::BufferIterator it=InBuffer->Data.begin();

	int PointPos=0;
	for (int q=0;q<IgnoreFirstNumPoints && it!=InBuffer->Data.end();q++,PointPos++) it++;		
	if (it==InBuffer->Data.end()) return; //nic nezbylo
   
	GPSPoint SouctovyPoint=*it;
	GPSPoint ZprumerovanyPoint=*it;
  	int PocetBodu=1;
	it++; //preskocime prvni uzel ktery uz jsme skopirovali
	PointPos++;
     		
	if (Precision>0.0)
	{
		for (;it!=InBuffer->Data.end() && PointPos<MaxSkipPoints;it++,PointPos++)
		{

			bool Found=false;
			GPSPointBuffer::BufferIterator it2=it;

			SouctovyPoint=ZprumerovanyPoint=*it2; //priradime prvni bod
			PocetBodu=1;
			it2++;
			int C=1;
			for (;it2!=InBuffer->Data.end();it2++,C++)
			{
				if (GPSPoint::Distance(ZprumerovanyPoint,*it2)<Precision && C+PointPos<MaxSkipPoints)
				{
					SouctovyPoint+=*it2;
					PocetBodu++;
					ZprumerovanyPoint=SouctovyPoint;
					ZprumerovanyPoint*=1.0f/PocetBodu;
				} 	
				else
				{
					if (PocetBodu>=MinMergedForStart)
					{
						//nasli jsme prvni zastavku vyskocime ven
						Found=true;
					}
					break;
				}
			}
			if (Found) 
			{
				it=it2;
				break; //povedlo se nam najit spravny pocet bodu->vyskocime 
			}
			//jinak se posuneme o jedn bod dale a zkusime to znova

		}
	}

	//zkopirujeme zbytek bufferu
	for (;it!=InBuffer->Data.end();it++)
		OutBuffer->Data.push_back(*it);
}
