#include "filter_removestairs.h"

void RemoveStairsFilter::ProcessBuffer(GPSPointBuffer::Holder InBuffer,GPSPointBuffer::Holder &OutBuffer)
{
	OutBuffer=NULL;
	if (InBuffer==NULL) return;
	
	GPSPointBuffer::BufferIterator it;
	const int PocetBodu=InBuffer->Data.size();

	int *StairIdsS=new int[PocetBodu+1]; //sem se bude zaznamenavat do ktereho schodu bod patri, pro sirku
	FTYPE *StairSValues=new FTYPE[PocetBodu+1]; //nebuze byt vice schodu nez kolik je vrcholu uvada hodnoty souradnic v jednotlivych stupnich
	FTYPE *StairSDelkaStart=new FTYPE[PocetBodu+1]; //nebuze byt vice schodu nez kolik je vrcholu uvada hodnoty souradnic v jednotlivych stupnich
	FTYPE *StairSDelkaEnd=new FTYPE[PocetBodu+1]; //nebuze byt vice schodu nez kolik je vrcholu uvada hodnoty souradnic v jednotlivych stupnich
	memset(StairIdsS,0,sizeof(int)*(PocetBodu+1));

	int *StairIdsD=new int[PocetBodu+1]; //sem se bude zaznamenavat do ktereho schodu bod patri, pro delku
	FTYPE *StairDValues=new FTYPE[PocetBodu+1]; //nebuze byt vice schodu nez kolik je vrcholu
	FTYPE *StairDDelkaStart=new FTYPE[PocetBodu+1]; //nebuze byt vice schodu nez kolik je vrcholu uvada hodnoty souradnic v jednotlivych stupnich
	FTYPE *StairDDelkaEnd=new FTYPE[PocetBodu+1]; //nebuze byt vice schodu nez kolik je vrcholu uvada hodnoty souradnic v jednotlivych stupnich
	memset(StairIdsD,0,sizeof(int)*(PocetBodu+1));


	InBuffer->Recalculate(GPSPB_WHAT_DELKANAKRIVCE);
	//spocitame delky na krivce, budou pouzity pro urcovani pomeru interpolace

	int StairIdS=0;
	int StairIdD=0;
	int Index=0;	
	GPSPointBuffer::BufferIterator it2=InBuffer->Data.begin();
	for (it=InBuffer->Data.begin();it!=InBuffer->Data.end();it++,Index++)
	{
		if (it==InBuffer->Data.begin())
		{
			//prvni bod->nic specialniho nedelame
			VECT3D &Current=*it;
			StairSValues[0]=Current.s;
			StairDValues[0]=Current.d;
			StairSDelkaStart[0]=it->DelkaNaKrivce;
			StairSDelkaEnd[0]=it->DelkaNaKrivce;
			StairDDelkaStart[0]=it->DelkaNaKrivce;
			StairDDelkaEnd[0]=it->DelkaNaKrivce;

		}
		else
		{
			//porovname s predchozim bodem
     			VECT3D &Old=*it2;
     			VECT3D &Current=*it;
			if (Current.s!=Old.s) 
			{
				StairIdS++; //doslo ke zmene v S zvetsime cislo schodu pro S souradnici
				StairSDelkaStart[StairIdS]=it->DelkaNaKrivce;
				StairSDelkaEnd[StairIdS]=it->DelkaNaKrivce;

			}
			if (Current.d!=Old.d) 
			{
				StairIdD++; //doslo ke zmene v D zvetsime cislo schodu pro D souradnici
				StairDDelkaStart[StairIdD]=it->DelkaNaKrivce;
				StairDDelkaEnd[StairIdD]=it->DelkaNaKrivce;
			}
			StairSValues[StairIdS]=Current.s;
			StairDValues[StairIdD]=Current.d;

			if (StairSDelkaEnd[StairIdS]<it->DelkaNaKrivce) StairSDelkaEnd[StairIdS]=it->DelkaNaKrivce;
			if (StairDDelkaEnd[StairIdD]<it->DelkaNaKrivce) StairDDelkaEnd[StairIdD]=it->DelkaNaKrivce;
		}
		it2=it;		
		StairIdsS[Index]=StairIdS;
		StairIdsD[Index]=StairIdD;


		
	}

	//ted mame v StairIdsS a StairIdsD uvedena cisla stupnu
	//v StairSValues a StairDValues mame uvedeny hodnoty souradnice pro stupne

	OutBuffer=new GPSPointBuffer;
	Index=0;
	for (it=InBuffer->Data.begin();it!=InBuffer->Data.end();it++,Index++)
	{
		FTYPE InterpolatedS=0;
		FTYPE InterpolatedD=0;
		{
			int StairIndex=StairIdsS[Index];
			int PreviousStairIndex=StairIndex-1;
			int NextStairIndex=StairIndex+1;

			FTYPE StairValue=StairSValues[StairIndex];
			FTYPE PreviousStairValue=(PreviousStairIndex>=0)?StairSValues[PreviousStairIndex]:StairSValues[StairIndex];
			FTYPE NextStairValue=(NextStairIndex<StairIdS)?StairSValues[NextStairIndex]:StairSValues[StairIndex];

			//hodnoty na zatku a na konci useku
			FTYPE PreviousValue=StairValue;
			FTYPE NextValue=StairValue;

			
			//vzdalenosti od zacatku krivky ve kterych se nachazeji hodnoty NextValue a PreviousValue
			FTYPE NewValuePreviousDelkaNaKrivce=StairSDelkaStart[StairIndex];
			FTYPE NewValueNextDelkaNaKrivce=StairSDelkaEnd[StairIndex];

			if (fabs(PreviousStairValue-StairValue)<MaximalStairSize) 
			{
			
				if (0<=PreviousStairIndex) NewValuePreviousDelkaNaKrivce=(NewValuePreviousDelkaNaKrivce+StairSDelkaEnd[PreviousStairIndex])/2;
				PreviousValue=(PreviousStairValue+StairValue)/2;
			}
			if (fabs(NextStairValue-StairValue)<MaximalStairSize) 
			{
				if (NextStairIndex<StairIdS) NewValueNextDelkaNaKrivce=(NewValueNextDelkaNaKrivce+StairSDelkaStart[NextStairIndex])/2;
				NextValue=(NextStairValue+StairValue)/2;
			}

			if (StairSDelkaEnd[StairIndex]!=StairSDelkaStart[StairIndex])
			{
				FTYPE InterpolationValue=(it->DelkaNaKrivce-NewValuePreviousDelkaNaKrivce)/(NewValueNextDelkaNaKrivce-NewValuePreviousDelkaNaKrivce);
				InterpolatedS=PreviousValue+(NextValue-PreviousValue)*InterpolationValue; 
			}
			else
				InterpolatedS=StairValue; //schod ma pouze jednu hodnotu->nechame ji 
		}

		{
			int StairIndex=StairIdsD[Index];
			int PreviousStairIndex=StairIndex-1;
			int NextStairIndex=StairIndex+1;

			FTYPE StairValue=StairDValues[StairIndex];
			FTYPE PreviousStairValue=(PreviousStairIndex>=0)?StairDValues[PreviousStairIndex]:StairDValues[StairIndex];
			FTYPE NextStairValue=(NextStairIndex<=StairIdD)?StairDValues[NextStairIndex]:StairDValues[StairIndex];

			//hodnoty na zatku a na konci useku
			FTYPE PreviousValue=StairValue;
			FTYPE NextValue=StairValue;


			//vzdalenosti od zacatku krivky ve kterych se nachazeji hodnoty NextValue a PreviousValue
			FTYPE NewValuePreviousDelkaNaKrivce=StairDDelkaStart[StairIndex];
			FTYPE NewValueNextDelkaNaKrivce=StairDDelkaEnd[StairIndex];
			
			if (fabs(PreviousStairValue-StairValue)<MaximalStairSize) 
			{
				if (0<=PreviousStairIndex) NewValuePreviousDelkaNaKrivce=(NewValuePreviousDelkaNaKrivce+StairDDelkaEnd[PreviousStairIndex])/2;
				PreviousValue=(PreviousStairValue+StairValue)/2;
			}
			if (fabs(NextStairValue-StairValue)<MaximalStairSize) 
			{
				if (NextStairIndex<StairIdS) NewValueNextDelkaNaKrivce=(NewValueNextDelkaNaKrivce+StairDDelkaStart[NextStairIndex])/2;
				NextValue=(NextStairValue+StairValue)/2;
			}


			if (StairDDelkaEnd[StairIndex]!=StairDDelkaStart[StairIndex])
			{
				FTYPE InterpolationValue=(it->DelkaNaKrivce-NewValuePreviousDelkaNaKrivce)/(NewValueNextDelkaNaKrivce-NewValuePreviousDelkaNaKrivce);
				InterpolatedD=PreviousValue+(NextValue-PreviousValue)*InterpolationValue; 
			}
			else
				InterpolatedD=StairValue; //schod ma pouze jednu hodnotu->nechame ji 
		}

		GPSPoint P=*it;
		VECT3D &V=P;
		V.s=InterpolatedS;
		V.d=InterpolatedD;	
		OutBuffer->Data.push_back(P);
	}

	
	GPSPointBuffer *IBuff=dynamic_cast<GPSPointBuffer *>(InBuffer.GetValue());
	GPSPointBuffer *OBuff=dynamic_cast<GPSPointBuffer *>(OutBuffer.GetValue());
	OBuff->FileName=IBuff->FileName;

	OutBuffer->Recalculate(GPSPB_WHAT_DELKANAKRIVCE);
	delete[] StairDDelkaEnd;
	delete[] StairDDelkaStart;
	delete[] StairDValues;
	delete[] StairIdsD;

	delete[] StairSDelkaEnd;
	delete[] StairSDelkaStart;
	delete[] StairSValues;
	delete[] StairIdsS;
}
